#k-means method for the weighted k-median problem
from pylab import *
from networkx import *  # import networkx after pylab 
from dialmethodsub2 import *

def CostEvaluate(G,partition,numnodes,k,alpha):
    cost=0
    for v in G:
        for w in G[v]:
            if partition[v]!=partition[w]:
                cost+=G.get_edge(v,w)
                #cost+=1
    cost=cost/2

    cost2=0
    for p in range(k):
        cost2+=numnodes[p]**2
    cost2*=alpha
    print "cost=",cost,cost2
    return cost,cost2

def Dis(x1,y1,x2,y2):
    xdiff = x2 - x1
    ydiff = y2 - y1
    return math.sqrt(xdiff*xdiff + ydiff*ydiff)

def kmeans(G,nodeweight,k):
    n=len(G)
    partition=numpy.zeros(n,numpy.int16)   
    nodes=G.nodes()
    random.shuffle(nodes)
    x=numpy.zeros(n,numpy.float)
    y=numpy.zeros(n,numpy.float)
    X=numpy.zeros(k,numpy.float)
    Y=numpy.zeros(k,numpy.float)
    newX=numpy.zeros(k,numpy.float)
    newY=numpy.zeros(k,numpy.float)
    for i in range(n):
        (x[i],y[i])=G.position[i]
    #print x,y
    for i in range(k):
        X[i]=x[nodes[i]]
        Y[i]=y[nodes[i]]
    #print X,Y

    while 1:
        #find the nearest facility
        nodelist=[[] for i in range(k)]
        for i in range(n):
            mindist=9999999.0
            minj=-1
            for j in range(k):
                dist=Dis(x[i],y[i],X[j],Y[j])
                if dist<mindist:
                    mindist=dist
                    minj=j
            nodelist[minj].append(i)
            
        #print len(nodelist[0]),len(nodelist[1])
        #find the gravity point
        for j in range(k):
            sumx=0.0
            sumy=0.0
            for i in nodelist[j]:
                sumx+=x[i]
                sumy+=y[i]
            if len(nodelist[j])>0:
                newX[j]=sumx/len(nodelist[j])
                newY[j]=sumy/len(nodelist[j])
        error=0.0
        for j in range(k):
            error+=Dis(X[j],Y[j],newX[j],newY[j])
        print "error=",error#,X,Y
        if error<=0.00001: break
        for j in range(k):
            X[j]=newX[j]
            Y[j]=newY[j]
    
    for j in range(k):
        for i in nodelist[j]:
            partition[i]=j
    return partition


if __name__ == "__main__":
    random.seed(1) 
    #filename="DC.tmp"
    #filename="NY.tmp"
    filename="USA-road-d.NY"
    #G,n,m,C,size = ReadDimacs(filename)
    G,n,C,size=Read2core(filename)
    print "n,C,size",n,C,size
    for (v,w,length) in G.edges_iter():
        if length==0:
            #G.add_edge(v,w,float(999999))
            G.add_edge(v,w,1.0)
        else:
            #G.add_edge(v,w,1.0/float(length))
            G.add_edge(v,w,1.0)
    G.info()

    
    nodeweight=numpy.ones(n,numpy.int16) 
    k=15 #find k-way partition
    #select random k points

    partition= kmeans(G,nodeweight,k)
     
    Border=[]
    BorderFlag=numpy.zeros(n,numpy.int0) 
    for (v,w,length) in G.edges_iter():
        if (partition[v] !=partition[w]) and (BorderFlag[v]==0) and (BorderFlag[w]==0): #border edge
            if G.degree(v)>G.degree(w):     
                Border.append(v)
                BorderFlag[v]=1
            else:
                Border.append(w)
                BorderFlag[w]=1
    print "number of border points",len(Border)
    draw(G,G.position,nodelist=Border,node_size=10,with_labels=None,width=0.1,node_color='r')
    show()
##    
##    Nodes=[]
##    for v in G:
##        if partition[v]==4:
##            Nodes.append(v)
##    draw(G,G.position,nodelist=Nodes,node_size=10,with_labels=None,width=0.1,node_color='r')
##    show()


#    draw(G,G.position,node_size=sizelist,with_labels=None,width=1,node_color='y')
#    draw(G0,G0.position,node_size=partition,with_labels=None,width=1,node_color='y')
#    show() # display
